import { Request } from "puppeteer";
import { Deferred } from "./delay";
import { Configuration } from "./decoder";
/**
 * Event handler for intercepting network requests during tests.
 *
 * @param interceptedRequest Request object
 */
export declare const makeOnRequest: (id: string, failurePattern: string[][][], buffer?: Deferred[], apis?: Configuration["apis"]) => (interceptedRequest: Request) => Promise<void>;
