import * as d from "io-ts/lib/Decoder";
import { Page } from "puppeteer";
declare class _<T> {
    Action: d.Decoder<unknown, ["delay", number] | ["resolve" | "waitForFocus", string] | ["waitForSelector" | "$" | "click" | "defer", string | string[]] | ["type", string, string | number] | ["select", string, string] | ["expectProperty", string, string, string | number | boolean] | ((page: T) => unknown)>;
    Configuration: d.Decoder<unknown, {
        id: string;
        visit: {
            path: string;
        };
        initial: string;
        states: Record<string, Partial<{
            xstate: Partial<{
                always: string;
            }>;
            type: "final";
            tests: (["delay", number] | ["resolve" | "waitForFocus", string] | ["waitForSelector" | "$" | "click" | "defer", string | string[]] | ["type", string, string | number] | ["select", string, string] | ["expectProperty", string, string, string | number | boolean] | ((page: TPage) => unknown))[];
            on: Record<string, Partial<{
                target: string;
                actions: (["delay", number] | ["resolve" | "waitForFocus", string] | ["waitForSelector" | "$" | "click" | "defer", string | string[]] | ["type", string, string | number] | ["select", string, string] | ["expectProperty", string, string, string | number | boolean] | ((page: TPage) => unknown))[];
            }>>;
        }>>;
    } & Partial<{
        beforVisit: (["delay", number] | ["resolve" | "waitForFocus", string] | ["waitForSelector" | "$" | "click" | "defer", string | string[]] | ["type", string, string | number] | ["select", string, string] | ["expectProperty", string, string, string | number | boolean] | ((page: TPage) => unknown))[];
        apis: (Partial<{
            deferrals: string[];
            outcomes: Record<string, Partial<{
                status: number;
                body: any;
            }>>;
        }> & {
            path: string;
        })[];
        outcomes: string[];
        viewport: {
            width: number;
            height: number;
        };
    }>>;
}
export declare type Action<P = Page> = d.TypeOf<_<P>["Action"]>;
export declare type Configuration<P = Page> = d.TypeOf<_<P>["Configuration"]>;
declare const _default: <TPage>(json: any) => import("fp-ts/lib/Either").Either<import("io-ts/lib/FreeSemigroup").FreeSemigroup<import("io-ts/lib/DecodeError").DecodeError<string>>, {
    id: string;
    visit: {
        path: string;
    };
    initial: string;
    states: Record<string, Partial<{
        xstate: Partial<{
            always: string;
        }>;
        type: "final";
        tests: (["delay", number] | ["resolve" | "waitForFocus", string] | ["waitForSelector" | "$" | "click" | "defer", string | string[]] | ["type", string, string | number] | ["select", string, string] | ["expectProperty", string, string, string | number | boolean] | ((page: TPage_1) => unknown))[];
        on: Record<string, Partial<{
            target: string;
            actions: (["delay", number] | ["resolve" | "waitForFocus", string] | ["waitForSelector" | "$" | "click" | "defer", string | string[]] | ["type", string, string | number] | ["select", string, string] | ["expectProperty", string, string, string | number | boolean] | ((page: TPage_1) => unknown))[];
        }>>;
    }>>;
} & Partial<{
    beforVisit: (["delay", number] | ["resolve" | "waitForFocus", string] | ["waitForSelector" | "$" | "click" | "defer", string | string[]] | ["type", string, string | number] | ["select", string, string] | ["expectProperty", string, string, string | number | boolean] | ((page: TPage_1) => unknown))[];
    apis: (Partial<{
        deferrals: string[];
        outcomes: Record<string, Partial<{
            status: number;
            body: any;
        }>>;
    }> & {
        path: string;
    })[];
    outcomes: string[];
    viewport: {
        width: number;
        height: number;
    };
}>>;
export default _default;
